                  /*--.          .-"-. 
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Authors note:   |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/

#ifndef _STACK_H_
#define _STACK_H_

template <class ARG_TYPE>
class StackNode {
public:
	ARG_TYPE object;
	StackNode *next;
};

template <class ARG_TYPE>
class Stack {
protected:
	int size;
	StackNode <ARG_TYPE> *top;
public:
	Stack(){
		size = 0;
		top = NULL;
	}

	~Stack(){
		StackNode <ARG_TYPE> *tmp, *node = top;

		while (node != NULL){
			tmp = node;
			node = node->next;
			delete tmp;
		}
	}

	void push(const ARG_TYPE object){
		StackNode <ARG_TYPE> *newNode = new StackNode <ARG_TYPE>;
		newNode->next = top;
		newNode->object = object;
		top = newNode;

		size++;
	}

	ARG_TYPE pop(){
		StackNode <ARG_TYPE> *oldNode = top;
		ARG_TYPE object = top->object;

		top = top->next;
		delete oldNode;

		size--;
		return object;
	}

	const int getSize(){
		return size;
	}
};

#endif // _STACK_H_